Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteDataDescriptor.cs	(revision 14744)
@@ -9,48 +9,48 @@
 
   using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
   using Microsoft.VisualBasic.FileIO;
 
-  public abstract class BenchmarkSuiteDataDescriptor : IBenchmarkSuiteDataDescriptor, IExampleParser {
-    protected const string InstanceArchiveName = "HeuristicLab.BenchmarkSuite.Data.BenchmarkExamples.zip";
-    protected const string ResourcePath = @".*\.Data\.";
-    protected const string ExampleSeparator = ",";
 
-    protected const char ArrayValueSeparator = ' ';
-    protected static readonly char[] ArraySymbolTrim = { '[', ']' };
+  [StorableClass]
+  public abstract class BenchmarkSuiteDataDescriptor : NamedItem, IBenchmarkSuiteDataDescriptor {
+    private const string InstanceArchiveName = "HeuristicLab.BenchmarkSuite.Data.BenchmarkExamples.zip";
+    private const string ResourcePath = @".*\.Data\.";
+    private const string ExampleSeparator = ",";
 
-    private readonly Lazy<Data> data;
-    private readonly Lazy<Example[]> examples;
+    private const char ArrayValueSeparator = ' ';
+    private static readonly char[] ArraySymbolTrim = { '[', ']' };
 
-    protected BenchmarkSuiteDataDescriptor() {
-      examples = new Lazy<Example[]>(ParseData().ToArray, false);
+    protected BenchmarkSuiteDataDescriptor() { }
+
+    [StorableConstructor]
+    protected BenchmarkSuiteDataDescriptor(bool deserializing) : base(deserializing) { }
+
+
+    [Storable]
+    private Example[] examples;
+    public Example[] Examples
+    {
+      get
+      {
+        return this.examples ?? (this.examples = this.ParseData().ToArray());
+      }
     }
 
-    protected Example[] Examples { get { return examples.Value; } }
-
-    public abstract string Name { get; }
-    public abstract string FileName { get; }
-    public abstract string Description { get; }
-    protected abstract int OriginalTrainingCount { get; }
-    protected abstract int OriginalTestCount { get; }
-    protected abstract int BestResult { get; }
-    protected abstract int WorstResult { get; }
-    protected abstract int InputArgumentCount { get; }
-    protected abstract int OutputArgumentCount { get; }
-    protected int TotalArgumentCount { get { return InputArgumentCount + OutputArgumentCount; } }
+    public new abstract string Name { get; }
+    protected abstract string FileName { get; }
+    public new abstract string Description { get; }
+    public abstract int OriginalTrainingCount { get; }
+    public abstract int OriginalTestCount { get; }
+    public abstract int BestResult { get; }
+    public abstract int WorstResult { get; }
+    public abstract int InputArgumentCount { get; }
+    public abstract int OutputArgumentCount { get; }
+    public int TotalArgumentCount { get { return InputArgumentCount + OutputArgumentCount; } }
 
     public abstract Example ParseExample(string[] input, string[] output);
-
-    public Data CreateData() {
-      return new Data(
-        BestResult,
-        WorstResult,
-        OriginalTestCount,
-        OriginalTrainingCount,
-        InputArgumentCount,
-        OutputArgumentCount,
-        Examples,
-        this);
-    }
 
     private IEnumerable<Example> ParseData() {
@@ -127,4 +127,8 @@
       throw new InvalidDataException(string.Format("Unable to parse {0} as boolean", str));
     }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return this;
+    }
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteInstanceProvider.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteInstanceProvider.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/BenchmarkSuiteInstanceProvider.cs	(revision 14744)
@@ -3,10 +3,9 @@
 
 namespace HeuristicLab.BenchmarkSuite {
-  using System.Linq;
 
   using HeuristicLab.BenchmarkSuite.Problems;
   using HeuristicLab.Problems.Instances;
 
-  public class BenchmarkSuiteInstanceProvider : ProblemInstanceProvider<Data> {
+  public class BenchmarkSuiteInstanceProvider : ProblemInstanceProvider<IBenchmarkSuiteDataDescriptor> {
     private const string name = "General Program Synthesis Benchmark Suite";
     private const string referencePublication =
@@ -53,8 +52,6 @@
     }
 
-    public override Data LoadData(IDataDescriptor descriptor) {
-      var benchmarkSuiteDataDescriptor = (IBenchmarkSuiteDataDescriptor)descriptor;
-
-      return benchmarkSuiteDataDescriptor.CreateData();
+    public override IBenchmarkSuiteDataDescriptor LoadData(IDataDescriptor descriptor) {
+      return (IBenchmarkSuiteDataDescriptor)descriptor;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/HeuristicLab.BenchmarkSuite.csproj	(revision 14744)
@@ -98,7 +98,5 @@
     <Compile Include="BenchmarkSuiteInstanceProvider.cs" />
     <Compile Include="IBenchmarkSuiteDataDescriptor.cs" />
-    <Compile Include="IExampleParser.cs" />
     <Compile Include="Plugin.cs" />
-    <Compile Include="Problems\Data.cs" />
     <Compile Include="Problems\Example.cs" />
     <Compile Include="Problems\ReplaceSpaceWithNewline.cs" />
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/IBenchmarkSuiteDataDescriptor.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/IBenchmarkSuiteDataDescriptor.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/IBenchmarkSuiteDataDescriptor.cs	(revision 14744)
@@ -1,8 +1,22 @@
 ﻿namespace HeuristicLab.BenchmarkSuite {
   using HeuristicLab.BenchmarkSuite.Problems;
+  using HeuristicLab.Core;
   using HeuristicLab.Problems.Instances;
 
-  public interface IBenchmarkSuiteDataDescriptor : IDataDescriptor {
-    Data CreateData();
+  public interface IBenchmarkSuiteDataDescriptor : IDataDescriptor, INamedItem {
+    //Data CreateData();
+    Example[] Examples { get; }
+
+    string Name { get; }
+    string Description { get; }
+    int OriginalTrainingCount { get; }
+    int OriginalTestCount { get; }
+    int BestResult { get; }
+    int WorstResult { get; }
+    int InputArgumentCount { get; }
+    int OutputArgumentCount { get; }
+    int TotalArgumentCount { get; }
+
+    Example ParseExample(string[] input, string[] output);
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Checksum.cs	(revision 14744)
@@ -3,18 +3,25 @@
   using System.Text;
 
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
   public class Checksum : BenchmarkSuiteDataDescriptor {
     private const string name = "Checksum";
     private const string fileName = "Checksum.csv";
     private const string description = "";
+    public Checksum() { }
+
+    [StorableConstructor]
+    public Checksum(bool deserializing) : base(deserializing) { }
 
     public override string Name { get { return name; } }
-    public override string FileName { get { return fileName; } }
+    protected override string FileName { get { return fileName; } }
     public override string Description { get { return description; } }
-    protected override int InputArgumentCount { get { return 1; } }
-    protected override int OutputArgumentCount { get { return 1; } }
-    protected override int OriginalTrainingCount { get { return 228; } }
-    protected override int OriginalTestCount { get { return 1254; } }
-    protected override int BestResult { get { return 0; } }
-    protected override int WorstResult { get { return byte.MaxValue; } }
+    public override int InputArgumentCount { get { return 1; } }
+    public override int OutputArgumentCount { get { return 1; } }
+    public override int OriginalTrainingCount { get { return 228; } }
+    public override int OriginalTestCount { get { return 1254; } }
+    public override int BestResult { get { return 0; } }
+    public override int WorstResult { get { return byte.MaxValue; } }
 
     public override Example ParseExample(string[] input, string[] output) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/CountOdds.cs	(revision 14744)
@@ -1,4 +1,6 @@
 ﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
+  [StorableClass]
   public class CountOdds : BenchmarkSuiteDataDescriptor {
     private const string name = "Count Odds";
@@ -6,13 +8,18 @@
     private const string description = "";
 
+    public CountOdds() { }
+
+    [StorableConstructor]
+    public CountOdds(bool deserializing) : base(deserializing) { }
+
     public override string Name { get { return name; } }
-    public override string FileName { get { return fileName; } }
     public override string Description { get { return description; } }
-    protected override int InputArgumentCount { get { return 1; } }
-    protected override int OutputArgumentCount { get { return 1; } }
-    protected override int OriginalTrainingCount { get { return 200; } }
-    protected override int OriginalTestCount { get { return 2000; } }
-    protected override int BestResult { get { return 0; } }
-    protected override int WorstResult { get { return 50; } }
+    protected override string FileName { get { return fileName; } }
+    public override int InputArgumentCount { get { return 1; } }
+    public override int OutputArgumentCount { get { return 1; } }
+    public override int OriginalTrainingCount { get { return 200; } }
+    public override int OriginalTestCount { get { return 2000; } }
+    public override int BestResult { get { return 0; } }
+    public override int WorstResult { get { return 50; } }
 
     public override Example ParseExample(string[] input, string[] output) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Example.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Example.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Example.cs	(revision 14744)
@@ -1,3 +1,4 @@
 ﻿namespace HeuristicLab.BenchmarkSuite.Problems {
+  using System;
 
   using HeuristicLab.Common;
@@ -23,14 +24,14 @@
 
     public void CopyTo(Example example) {
-      example.InputArgs = this.InputArgs;
-      example.OutputArgs = this.OutputArgs;
+      Array.Copy(InputArgs, example.InputArgs, InputArgs.Length);
+      Array.Copy(OutputArgs, example.OutputArgs, OutputArgs.Length);
 
-      example.InputBoolean = this.InputBoolean;
-      example.InputInt = this.InputInt;
-      example.InputFloat = this.InputFloat;
+      Array.Copy(InputBoolean, example.InputBoolean, InputBoolean.Length);
+      Array.Copy(InputInt, example.InputInt, InputInt.Length);
+      Array.Copy(InputFloat, example.InputFloat, InputFloat.Length);
 
-      example.OutputBoolean = this.OutputBoolean;
-      example.OutputInt = this.OutputInt;
-      example.OutputFloat = this.OutputFloat;
+      Array.Copy(OutputBoolean, example.OutputBoolean, OutputBoolean.Length);
+      Array.Copy(OutputInt, example.OutputInt, OutputInt.Length);
+      Array.Copy(OutputFloat, example.OutputFloat, OutputFloat.Length);
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.cs	(revision 14744)
@@ -2,11 +2,9 @@
 
 namespace HeuristicLab.BenchmarkSuite.Views {
-
-  using HeuristicLab.BenchmarkSuite.Problems;
   using HeuristicLab.Core.Views;
   using HeuristicLab.MainForm;
 
   [View("Push Expression Selection Editor")]
-  [Content(typeof(Data), true)]
+  [Content(typeof(IBenchmarkSuiteDataDescriptor), true)]
   public partial class DataEditorView : NamedItemView {
     public DataEditorView() {
@@ -35,5 +33,5 @@
 
       try {
-        var newExample = Content.ExampleParser.ParseExample(inputArgs, outputArgs);
+        var newExample = Content.ParseExample(inputArgs, outputArgs);
         newExample.CopyTo(example);
       }
@@ -48,7 +46,7 @@
     }
 
-    public new Data Content
+    public new IBenchmarkSuiteDataDescriptor Content
     {
-      get { return (Data)base.Content; }
+      get { return (IBenchmarkSuiteDataDescriptor)base.Content; }
       set
       {
@@ -64,7 +62,4 @@
 
     protected override void OnContentChanged() {
-      const string inputPrefix = "in_";
-      const string outputPrefix = "out_";
-
       dataGridView.Columns.Clear();
       dataGridView.Rows.Clear();
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14744)
@@ -116,7 +116,8 @@
     <Compile Include="Push\Configuration\IEnabledExpressionsConfiguration.cs" />
     <Compile Include="Push\Creator\PointsBasedPushProgramCreator.cs" />
+    <Compile Include="Push\Data\List\SkipList.cs" />
+    <Compile Include="Push\Data\Pool\ManagedPool.cs" />
     <Compile Include="Push\Data\Pool\ObjectPool.cs" />
-    <Compile Include="Push\Data\Tree\ExpressionNode.cs" />
-    <Compile Include="Push\Data\Tree\ExpressionTree.cs" />
+    <Compile Include="Push\Data\Pool\PoolContainer.cs" />
     <Compile Include="Push\Exporter\Exporter.cs" />
     <Compile Include="Push\Expressions\BooleanExpressions.cs" />
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj.user
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj.user	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj.user	(revision 14744)
@@ -7,8 +7,10 @@
     <StartAction>Program</StartAction>
     <StartProgram>T:\BTSync\projects\svn\hl\trunk\sources\bin\HeuristicLab 3.3.exe</StartProgram>
+    <StartArguments>/hideStarter /start:Optimizer</StartArguments>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|AnyCPU'">
     <StartAction>Program</StartAction>
     <StartProgram>T:\BTSync\projects\svn\hl\trunk\sources\bin\HeuristicLab 3.3.exe</StartProgram>
+    <StartArguments>/hideStarter /start:Optimizer</StartArguments>
   </PropertyGroup>
 </Project>
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 14744)
@@ -0,0 +1,25 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {
+  using System.Collections.Generic;
+
+  public interface IReadonlyPushConfiguration {
+    bool IsBooleanStackEnabled { get; }
+    bool IsIntegerStackEnabled { get; }
+    bool IsFloatStackEnabled { get; }
+    bool IsCodeStackEnabled { get; }
+    bool IsNameStackEnabled { get; }
+    double ErcProbability { get; }
+    int EvalPushLimit { get; }
+    int MaxDepth { get; }
+    int MaxPointsInProgram { get; }
+    int MaxPointsInRandomExpression { get; }
+    bool TopLevelPushCode { get; }
+    bool TopLevelPopCode { get; }
+    int MinRandomInteger { get; }
+    int MaxRandomInteger { get; }
+    double MinRandomFloat { get; }
+    double MaxRandomFloat { get; }
+    double NewErcNameProbability { get; }
+
+    IReadOnlyList<string> EnabledExpressions { get; }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 14744)
@@ -0,0 +1,357 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {
+  using System;
+  using System.Collections.Generic;
+  using System.Linq;
+
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+
+  [StorableClass]
+  public class PushConfiguration : NamedItem, IReadonlyPushConfiguration, IEnabledExpressionsConfiguration {
+    private static readonly string itemName = "PushGP Configuration";
+
+    public PushConfiguration() {
+      this.EvalPushLimit = 4096;
+      this.MaxPointsInProgram = 128;
+      this.MaxPointsInRandomExpression = 64;
+
+      this.TopLevelPushCode = true;
+      this.TopLevelPopCode = false;
+
+      this.MinRandomInteger = -128;
+      this.MaxRandomInteger = 128;
+      this.MinRandomFloat = -128D;
+      this.MaxRandomFloat = 128D;
+      this.NewErcNameProbability = 0.5;
+      this.ErcProbability = 0.2;
+
+      this.EnabledExpressions = ExpressionTable.ExpressionNames.ToList();
+    }
+
+    [StorableConstructor]
+    public PushConfiguration(bool deserializing) : base(deserializing) { }
+
+    public PushConfiguration(PushConfiguration origin, Cloner cloner) : base(origin, cloner) {
+      this.EnabledExpressions = origin.EnabledExpressions.ToList();
+
+      this.EvalPushLimit = origin.EvalPushLimit;
+      this.MaxPointsInProgram = origin.MaxPointsInProgram;
+      this.MaxPointsInRandomExpression = origin.MaxPointsInRandomExpression;
+
+      this.TopLevelPushCode = origin.TopLevelPushCode;
+      this.TopLevelPopCode = origin.TopLevelPopCode;
+
+      this.MinRandomInteger = origin.MinRandomInteger;
+      this.MaxRandomInteger = origin.MaxRandomInteger;
+      this.MinRandomFloat = origin.MinRandomFloat;
+      this.MaxRandomFloat = origin.MaxRandomFloat;
+      this.NewErcNameProbability = origin.NewErcNameProbability;
+      this.ErcProbability = origin.ErcProbability;
+
+      this.isBooleanStackEnabled = origin.IsBooleanStackEnabled;
+      this.isIntegerStackEnabled = origin.IsIntegerStackEnabled;
+      this.isFloatStackEnabled = origin.IsFloatStackEnabled;
+      this.isNameStackEnabled = origin.IsNameStackEnabled;
+      this.isCodeStackEnabled = origin.IsCodeStackEnabled;
+      this.isExecStackEnabled = origin.IsExecStackEnable;
+    }
+
+    public event EventHandler<EnabledExpressionsChangedEventArgs> EnabledExpressionsChanged;
+
+    [Storable]
+    public IList<string> EnabledExpressions { get; private set; }
+
+    IReadOnlyList<string> IReadonlyPushConfiguration.EnabledExpressions { get { return this.EnabledExpressions as IReadOnlyList<string>; } }
+
+    [Storable]
+    private bool isBooleanStackEnabled = true;
+
+    public bool IsBooleanStackEnabled
+    {
+      get
+      {
+        return this.isBooleanStackEnabled;
+      }
+
+      set
+      {
+        if (this.isBooleanStackEnabled == value) return;
+
+        this.isBooleanStackEnabled = value;
+
+        if (this.isBooleanStackEnabled) EnableExpressionOfStack(StackType.Boolean);
+        else DisableExpressionOfStack(StackType.Boolean);
+      }
+    }
+
+    [Storable]
+    private bool isIntegerStackEnabled = true;
+
+    public bool IsIntegerStackEnabled
+    {
+      get
+      {
+        return this.isIntegerStackEnabled;
+      }
+
+      set
+      {
+        if (this.isIntegerStackEnabled == value) return;
+
+        this.isIntegerStackEnabled = value;
+
+        if (this.isIntegerStackEnabled) EnableExpressionOfStack(StackType.Integer);
+        else DisableExpressionOfStack(StackType.Integer);
+      }
+    }
+
+    [Storable]
+    private bool isFloatStackEnabled = true;
+
+    public bool IsFloatStackEnabled
+    {
+      get
+      {
+        return this.isFloatStackEnabled;
+      }
+
+      set
+      {
+        if (this.isFloatStackEnabled == value) return;
+
+        this.isFloatStackEnabled = value;
+
+        if (this.isFloatStackEnabled) EnableExpressionOfStack(StackType.Float);
+        else DisableExpressionOfStack(StackType.Float);
+      }
+    }
+
+    [Storable]
+    private bool isCodeStackEnabled = true;
+
+    public bool IsCodeStackEnabled
+    {
+      get
+      {
+        return this.isCodeStackEnabled;
+      }
+
+      set
+      {
+        if (this.isCodeStackEnabled == value) return;
+
+        this.isCodeStackEnabled = value;
+
+        if (this.isCodeStackEnabled) EnableExpressionOfStack(StackType.Code);
+        else DisableExpressionOfStack(StackType.Code);
+      }
+    }
+
+    [Storable]
+    private bool isExecStackEnabled = true;
+
+    public bool IsExecStackEnable
+    {
+      get
+      {
+        return this.isExecStackEnabled;
+      }
+
+      set
+      {
+        if (this.isExecStackEnabled == value) return;
+
+        this.isExecStackEnabled = value;
+
+        if (this.isExecStackEnabled) EnableExpressionOfStack(StackType.Exec);
+        else DisableExpressionOfStack(StackType.Exec);
+      }
+    }
+
+    [Storable]
+    private bool isNameStackEnabled = true;
+
+    public bool IsNameStackEnabled
+    {
+      get
+      {
+        return this.isNameStackEnabled;
+      }
+
+      set
+      {
+        if (this.isNameStackEnabled == value) return;
+
+        this.isNameStackEnabled = value;
+
+        if (this.isNameStackEnabled) EnableExpressionOfStack(StackType.Name);
+        else DisableExpressionOfStack(StackType.Name);
+      }
+    }
+
+    [Storable]
+    public double ErcProbability { get; set; }
+
+    /// <summary>
+    ///     This is the maximum allowed number of "executions" in a single top-level call to the interpreter.
+    ///     The execution of a single Push instruction counts as one execution, as does the processing of a single literal,
+    ///     as does the descent into one layer of parentheses (that is, the processing of the "(" counts as one execution).
+    ///     When this limit is exceeded the interpreter aborts immediately, leaving its stacks in the states they were in prior
+    ///     to the abort (so they may still be examined by a calling program). Whether or not this counts as an "abnormal"
+    ///     termination
+    ///     is up to the calling program.
+    /// </summary>
+    [Storable]
+    public int EvalPushLimit { get; set; }
+
+    /// <summary>
+    /// This is the maximum of depth a push program can have. Expressions, which lead to exceed this limit are interpreted as NOOP.
+    /// </summary>
+    [Storable]
+    public int MaxDepth { get; set; }
+
+    /// <summary>
+    ///     This is the maximum size of an item on the CODE stack, expressed as a number of points.
+    ///     A point is an instruction, a literal, or a pair of parentheses. Any instruction that would cause this limit to be
+    ///     exceeded
+    ///     should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the
+    ///     instruction.
+    /// </summary>
+    [Storable]
+    public int MaxPointsInProgram { get; set; }
+
+    /// <summary>
+    ///     The maximum number of points in an expression produced by the CODE.RAND instruction.
+    /// </summary>
+    [Storable]
+    public int MaxPointsInRandomExpression { get; set; }
+
+    /// <summary>
+    ///     When TRUE (which is the default), code passed to the top level of the interpreter
+    ///     will be pushed onto the CODE stack prior to execution.
+    /// </summary>
+    [Storable]
+    public bool TopLevelPushCode { get; set; }
+
+    /// <summary>
+    ///     When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.
+    /// </summary>
+    [Storable]
+    public bool TopLevelPopCode { get; set; }
+
+    /// <summary>
+    ///     The minimum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
+    /// </summary>
+    [Storable]
+    public int MinRandomInteger { get; set; }
+
+    /// <summary>
+    ///     The maximum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
+    /// </summary>
+    [Storable]
+    public int MaxRandomInteger { get; set; }
+
+    /// <summary>
+    ///     The minimum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
+    /// </summary>
+    [Storable]
+    public double MinRandomFloat { get; set; }
+
+    /// <summary>
+    ///     The maximum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
+    /// </summary>
+    [Storable]
+    public double MaxRandomFloat { get; set; }
+
+    /// <summary>
+    ///     The probability that the selection of the ephemeral
+    ///     random NAME constant for inclusion in randomly generated code will produce a new name
+    ///     (rather than a name that was previously generated).
+    /// </summary>
+    [Storable]
+    public double NewErcNameProbability { get; set; }
+
+    public void EnableExpressionOfStack(StackType type) {
+      foreach (var name in ExpressionTable.StackTypeToNamesTable[type]) {
+        EnableExpression(name);
+      }
+    }
+
+    public void DisableExpressionOfStack(StackType type) {
+      foreach (var name in ExpressionTable.StackTypeToNamesTable[type]) {
+        DisableExpression(name);
+      }
+    }
+
+    public void EnableExpression(string name) {
+      if (EnabledExpressions.Contains(name)) return;
+
+      EnabledExpressions.Add(name);
+
+      if (EnabledExpressionsChanged != null) {
+        EnabledExpressionsChanged.Invoke(this, new EnabledExpressionsChangedEventArgs(
+          new[] { name },
+          new string[0]));
+      }
+    }
+
+    public void DisableExpression(string name) {
+      if (!EnabledExpressions.Contains(name)) return;
+
+      EnabledExpressions.Remove(name);
+
+      if (EnabledExpressionsChanged != null) {
+        EnabledExpressionsChanged.Invoke(this, new EnabledExpressionsChangedEventArgs(
+          new string[0],
+          new[] { name }));
+      }
+    }
+
+    public void EnableExpression<T>() where T : Expression {
+      var attribute = (PushExpressionAttribute)Attribute.GetCustomAttribute(typeof(T), typeof(PushExpressionAttribute));
+      EnableExpression(attribute.ExpressionName);
+    }
+
+    public void DisableExpression<T>() where T : Expression {
+      var attribute = (PushExpressionAttribute)Attribute.GetCustomAttribute(typeof(T), typeof(PushExpressionAttribute));
+      DisableExpression(attribute.ExpressionName);
+    }
+
+    public void EnableStack(StackType type) {
+      SetStack(type, true);
+    }
+
+    public void DisableStack(StackType type) {
+      SetStack(type, false);
+    }
+
+    private void SetStack(StackType type, bool value) {
+      switch (type) {
+        case StackType.Boolean:
+          IsBooleanStackEnabled = value;
+          break;
+        case StackType.Integer:
+          IsIntegerStackEnabled = value;
+          break;
+        case StackType.Float:
+          IsFloatStackEnabled = value;
+          break;
+        case StackType.Name:
+          IsNameStackEnabled = value;
+          break;
+        case StackType.Code:
+          IsCodeStackEnabled = value;
+          break;
+        default: throw new InvalidOperationException("Stacktype unkown");
+      }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PushConfiguration(this, cloner);
+    }
+  }
+}
